

// This C++ file was created by SanEditor

#include "Atomic/software_channel/software_channelSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         software_channelSAN Constructor             
******************************************************************/


software_channelSAN::software_channelSAN(){


  Activity* InitialActionList[10]={
    &Attack_Processed, //0
    &StartCleansing, //1
    &ChInitDoOnce, //2
    &StartPatching, //3
    &bufferSyncAttack, //4
    &execSyncAttack, //5
    &PatchingInterval, //6
    &CleansingDuration, //7
    &PatchingDuration, //8
    &processSync  // 9
  };

  BaseGroupClass* InitialGroupList[10]={
    (BaseGroupClass*) &(PatchingInterval), 
    (BaseGroupClass*) &(CleansingDuration), 
    (BaseGroupClass*) &(PatchingDuration), 
    (BaseGroupClass*) &(processSync), 
    (BaseGroupClass*) &(Attack_Processed), 
    (BaseGroupClass*) &(StartCleansing), 
    (BaseGroupClass*) &(ChInitDoOnce), 
    (BaseGroupClass*) &(StartPatching), 
    (BaseGroupClass*) &(bufferSyncAttack), 
    (BaseGroupClass*) &(execSyncAttack)
  };

  PatchingEnabled = new Place("PatchingEnabled" ,patching_enabled);
  successful_attack_occured = new Place("successful_attack_occured" ,0);
  CleansingTriggered = new Place("CleansingTriggered" ,0);
  PatchingTakingPlace = new Place("PatchingTakingPlace" ,0);
  CleansingCounter = new Place("CleansingCounter" ,0);
  PatchingCounter = new Place("PatchingCounter" ,0);
  attackCounter = new Place("attackCounter" ,0);
  SystemStateUpdate = new Place("SystemStateUpdate" ,0);
  Cleansing = new Place("Cleansing" ,0);
  Channel_Init = new Place("Channel_Init" ,0);
  Initialised_counter = new Place("Initialised_counter" ,0);
  maxDemands = new Place("maxDemands" ,0);
  initTokens = new Place("initTokens" ,0);
  ChannelDown = new Place("ChannelDown" ,0);
  Mutex = new Place("Mutex" ,0);
  channel_attacked = new Place("channel_attacked" ,0);
  syncroAttack_occurred = new Place("syncroAttack_occurred" ,0);
  SyncDemand = new Place("SyncDemand" ,0);
  DataFromBuffer = new Place("DataFromBuffer" ,0);
  syncAttackSignal = new Place("syncAttackSignal" ,0);
  FlagSync = new Place("FlagSync" ,0);
  compromiseDetected = new Place("compromiseDetected" ,0);
  PatchBuffer = new Place("PatchBuffer" ,0);
  channelAttack_state temp_attackDetailchannelAttack = {0,{0,0,0,0}};
  attackDetail = new channelAttack("attackDetail",temp_attackDetailchannelAttack);
  channelState_state temp_ChannelStatechannelState = {0,0,0,0,0,{{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}},0};
  ChannelState = new channelState("ChannelState",temp_ChannelStatechannelState);
  FR_description_state temp_FR_DefinitionFR_Arrayvalue = {0,0};
  FR_Definition = new FR_Array("FR_Definition",temp_FR_DefinitionFR_Arrayvalue);
  ChannelAttackList_state temp_ChanAttackListChannelAttackList = {0,{{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}}};
  ChanAttackList = new ChannelAttackList("ChanAttackList",temp_ChanAttackListChannelAttackList);
  ChannelAttackList_state temp_SyncBufferChannelAttackList = {0,{{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}}};
  SyncBuffer = new ChannelAttackList("SyncBuffer",temp_SyncBufferChannelAttackList);
  channelAttack_state temp_copyAttackDetailchannelAttack = {0,{0,0,0,0}};
  copyAttackDetail = new channelAttack("copyAttackDetail",temp_copyAttackDetailchannelAttack);
  channelAttack_state temp_c_attackDetailchannelAttack = {0,{0,0,0,0}};
  c_attackDetail = new channelAttack("c_attackDetail",temp_c_attackDetailchannelAttack);
  BaseStateVariableClass* InitialPlaces[30]={
    PatchingEnabled,  // 0
    successful_attack_occured,  // 1
    CleansingTriggered,  // 2
    PatchingTakingPlace,  // 3
    CleansingCounter,  // 4
    PatchingCounter,  // 5
    attackCounter,  // 6
    SystemStateUpdate,  // 7
    Cleansing,  // 8
    Channel_Init,  // 9
    Initialised_counter,  // 10
    maxDemands,  // 11
    initTokens,  // 12
    ChannelDown,  // 13
    Mutex,  // 14
    channel_attacked,  // 15
    syncroAttack_occurred,  // 16
    SyncDemand,  // 17
    DataFromBuffer,  // 18
    syncAttackSignal,  // 19
    FlagSync,  // 20
    compromiseDetected,  // 21
    PatchBuffer,  // 22
    attackDetail,  // 23
    ChannelState,  // 24
    FR_Definition,  // 25
    ChanAttackList,  // 26
    SyncBuffer,  // 27
    copyAttackDetail,  // 28
    c_attackDetail   // 29
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("software_channel", 30, InitialPlaces, 
                        0, InitialROPlaces, 
                        10, InitialActionList, 10, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[66][2]={ 
    {1,0}, {6,0}, {24,0}, {23,0}, {28,0}, {20,0}, {19,0}, {7,0}, 
    {21,0}, {25,0}, {8,1}, {2,1}, {14,1}, {24,1}, {15,1}, {7,1}, 
    {9,2}, {10,2}, {24,2}, {11,2}, {12,2}, {13,3}, {22,3}, {3,3}, 
    {14,3}, {21,3}, {24,3}, {15,3}, {7,3}, {16,4}, {17,4}, {29,4}, 
    {24,4}, {27,4}, {18,5}, {6,5}, {24,5}, {23,5}, {28,5}, {20,5}, 
    {19,5}, {7,5}, {21,5}, {25,5}, {0,6}, {3,6}, {8,7}, {4,7}, 
    {24,7}, {14,7}, {15,7}, {7,7}, {13,8}, {0,8}, {5,8}, {24,8}, 
    {22,8}, {14,8}, {15,8}, {7,8}, {26,8}, {17,9}, {18,9}, {20,9}, 
    {23,9}, {27,9}
  };
  for(int n=0;n<66;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[13][2]={ 
    {1,0}, {2,1}, {14,1}, {9,2}, {3,3}, {14,3}, {21,3}, {16,4}, 
    {18,5}, {0,6}, {8,7}, {13,8}, {17,9}
  };
  for(int n=0;n<13;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<10;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void software_channelSAN::CustomInitialization() {

}
software_channelSAN::~software_channelSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void software_channelSAN::assignPlacesToActivitiesInst(){
  Attack_Processed.successful_attack_occured = (Place*) LocalStateVariables[1];
  Attack_Processed.attackCounter = (Place*) LocalStateVariables[6];
  Attack_Processed.ChannelState = (channelState*) LocalStateVariables[24];
  Attack_Processed.attackDetail = (channelAttack*) LocalStateVariables[23];
  Attack_Processed.copyAttackDetail = (channelAttack*) LocalStateVariables[28];
  Attack_Processed.FlagSync = (Place*) LocalStateVariables[20];
  Attack_Processed.syncAttackSignal = (Place*) LocalStateVariables[19];
  Attack_Processed.SystemStateUpdate = (Place*) LocalStateVariables[7];
  Attack_Processed.compromiseDetected = (Place*) LocalStateVariables[21];
  Attack_Processed.FR_Definition = (FR_Array*) LocalStateVariables[25];
  StartCleansing.CleansingTriggered = (Place*) LocalStateVariables[2];
  StartCleansing.Mutex = (Place*) LocalStateVariables[14];
  StartCleansing.Cleansing = (Place*) LocalStateVariables[8];
  StartCleansing.ChannelState = (channelState*) LocalStateVariables[24];
  StartCleansing.channel_attacked = (Place*) LocalStateVariables[15];
  StartCleansing.SystemStateUpdate = (Place*) LocalStateVariables[7];
  ChInitDoOnce.Channel_Init = (Place*) LocalStateVariables[9];
  ChInitDoOnce.Initialised_counter = (Place*) LocalStateVariables[10];
  ChInitDoOnce.ChannelState = (channelState*) LocalStateVariables[24];
  ChInitDoOnce.maxDemands = (Place*) LocalStateVariables[11];
  ChInitDoOnce.initTokens = (Place*) LocalStateVariables[12];
  StartPatching.PatchingTakingPlace = (Place*) LocalStateVariables[3];
  StartPatching.Mutex = (Place*) LocalStateVariables[14];
  StartPatching.compromiseDetected = (Place*) LocalStateVariables[21];
  StartPatching.ChannelDown = (Place*) LocalStateVariables[13];
  StartPatching.PatchBuffer = (Place*) LocalStateVariables[22];
  StartPatching.ChannelState = (channelState*) LocalStateVariables[24];
  StartPatching.channel_attacked = (Place*) LocalStateVariables[15];
  StartPatching.SystemStateUpdate = (Place*) LocalStateVariables[7];
  bufferSyncAttack.syncroAttack_occurred = (Place*) LocalStateVariables[16];
  bufferSyncAttack.SyncDemand = (Place*) LocalStateVariables[17];
  bufferSyncAttack.c_attackDetail = (channelAttack*) LocalStateVariables[29];
  bufferSyncAttack.ChannelState = (channelState*) LocalStateVariables[24];
  bufferSyncAttack.SyncBuffer = (ChannelAttackList*) LocalStateVariables[27];
  execSyncAttack.DataFromBuffer = (Place*) LocalStateVariables[18];
  execSyncAttack.attackCounter = (Place*) LocalStateVariables[6];
  execSyncAttack.ChannelState = (channelState*) LocalStateVariables[24];
  execSyncAttack.attackDetail = (channelAttack*) LocalStateVariables[23];
  execSyncAttack.copyAttackDetail = (channelAttack*) LocalStateVariables[28];
  execSyncAttack.FlagSync = (Place*) LocalStateVariables[20];
  execSyncAttack.syncAttackSignal = (Place*) LocalStateVariables[19];
  execSyncAttack.SystemStateUpdate = (Place*) LocalStateVariables[7];
  execSyncAttack.compromiseDetected = (Place*) LocalStateVariables[21];
  execSyncAttack.FR_Definition = (FR_Array*) LocalStateVariables[25];
}
void software_channelSAN::assignPlacesToActivitiesTimed(){
  PatchingInterval.PatchingEnabled = (Place*) LocalStateVariables[0];
  PatchingInterval.PatchingTakingPlace = (Place*) LocalStateVariables[3];
  CleansingDuration.Cleansing = (Place*) LocalStateVariables[8];
  CleansingDuration.CleansingCounter = (Place*) LocalStateVariables[4];
  CleansingDuration.ChannelState = (channelState*) LocalStateVariables[24];
  CleansingDuration.Mutex = (Place*) LocalStateVariables[14];
  CleansingDuration.channel_attacked = (Place*) LocalStateVariables[15];
  CleansingDuration.SystemStateUpdate = (Place*) LocalStateVariables[7];
  PatchingDuration.ChannelDown = (Place*) LocalStateVariables[13];
  PatchingDuration.PatchingEnabled = (Place*) LocalStateVariables[0];
  PatchingDuration.PatchingCounter = (Place*) LocalStateVariables[5];
  PatchingDuration.ChannelState = (channelState*) LocalStateVariables[24];
  PatchingDuration.PatchBuffer = (Place*) LocalStateVariables[22];
  PatchingDuration.Mutex = (Place*) LocalStateVariables[14];
  PatchingDuration.channel_attacked = (Place*) LocalStateVariables[15];
  PatchingDuration.SystemStateUpdate = (Place*) LocalStateVariables[7];
  PatchingDuration.ChanAttackList = (ChannelAttackList*) LocalStateVariables[26];
  processSync.SyncDemand = (Place*) LocalStateVariables[17];
  processSync.DataFromBuffer = (Place*) LocalStateVariables[18];
  processSync.FlagSync = (Place*) LocalStateVariables[20];
  processSync.attackDetail = (channelAttack*) LocalStateVariables[23];
  processSync.SyncBuffer = (ChannelAttackList*) LocalStateVariables[27];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================Attack_ProcessedActivity========================*/


software_channelSAN::Attack_ProcessedActivity::Attack_ProcessedActivity(){
  ActivityInitialize("Attack_Processed",4,Instantaneous , RaceEnabled, 10,1, false);
}

void software_channelSAN::Attack_ProcessedActivity::LinkVariables(){
  successful_attack_occured->Register(&successful_attack_occured_Mobius_Mark);
  attackCounter->Register(&attackCounter_Mobius_Mark);



  FlagSync->Register(&FlagSync_Mobius_Mark);
  syncAttackSignal->Register(&syncAttackSignal_Mobius_Mark);
  SystemStateUpdate->Register(&SystemStateUpdate_Mobius_Mark);
  compromiseDetected->Register(&compromiseDetected_Mobius_Mark);

}

bool software_channelSAN::Attack_ProcessedActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(successful_attack_occured_Mobius_Mark)) >=1));
  return NewEnabled;
}

double software_channelSAN::Attack_ProcessedActivity::Weight(){ 
  return 1;
}

bool software_channelSAN::Attack_ProcessedActivity::ReactivationPredicate(){ 
  return false;
}

bool software_channelSAN::Attack_ProcessedActivity::ReactivationFunction(){ 
  return false;
}

double software_channelSAN::Attack_ProcessedActivity::SampleDistribution(){
  return 0;
}

double* software_channelSAN::Attack_ProcessedActivity::ReturnDistributionParameters(){
    return NULL;
}

int software_channelSAN::Attack_ProcessedActivity::Rank(){
  return 1;
}

BaseActionClass* software_channelSAN::Attack_ProcessedActivity::Fire(){
  (*(successful_attack_occured_Mobius_Mark))--;
  int i,j,k,found_1;
int found = 0;
int curr_empty;
double pfd_increment = (double)(0.0);
double prob_threshold;
// Add the attack to the state and uldate the pfd figures 
i = ChannelState->channel_ID->Mark();
cout << "\n\nAttack Proc Gate\nChannel attacked:" << i << "\tAttack ID:" << attackDetail->demandDescription->ID->Mark() << "\n";
for(i=0;i<20;i++)
  {
    if(attackDetail->demandDescription->ID->Mark() == ChannelState->attacksApplied->Index(i)->ID->Mark())
 	found = 1;
    if(ChannelState->attacksApplied->Index(i)->ID->Mark() == 0)
      {
	curr_empty = i;		// Set the index of the first empty entry.
	break;
      }
   };
// Check if demand has already been applied. If so - do nothing. Otherwise add the demand to list of demands. 
if(found == 0)
  {
    // Not found: must add the new demandID to the list of demands.
    ChannelState->attacksApplied->Index(curr_empty)->ID->Mark() = attackDetail->demandDescription->ID->Mark();
    pfd_increment = (double)(0.0);
    for(i=0;i<10;i++)
      {
	// Here to copy the items of the FR_set
	if(attackDetail->demandDescription->FR_set->Index(i)->Mark() == 0)
	  break;	// If the item is set to 0, then abort. 
	ChannelState->attacksApplied->Index(curr_empty)->FR_set->Index(i)->Mark() = attackDetail->demandDescription->FR_set->Index(i)->Mark();
	found_1 = 0;
	for(j=0;j<100;j++)
	  {
	    if(attackDetail->demandDescription->FR_set->Index(i)->Mark() == ChannelState->FR_List->Index(j)->Mark())
	      found_1 = 1;
	    if(ChannelState->FR_List->Index(j)->Mark() == 0)
	      break;
	  };
	if(found_1 == 0)
	  {
	     // Here 'j' index contains the first empty location
	     ChannelState->FR_List->Index(j)->Mark() = attackDetail->demandDescription->FR_set->Index(i)->Mark();
	     // Now look up the contribution of this FR and add it to pfd_increment
	     for(k=0;k<100;k++)
		{
		  if(attackDetail->demandDescription->FR_set->Index(i)->Mark() == FR_Definition->Index(k)->ID->Mark())
		    pfd_increment += FR_Definition->Index(k)->pfd_size->Mark();
		};
	  }
      };
    // Add pfd_increment to this channel's pfd. 
    // This requires a pass through the ChannelState->FR_List.
    ChannelState->currentPfd->Mark() += pfd_increment;
  }
if((int)(time_sync_enabled) > 0)
  {
    // Copy attack details to copyAttackDetail of shared place
    copyAttackDetail->ChanID->Mark() = attackDetail->ChanID->Mark();
    copyAttackDetail->demandDescription->ID->Mark() = attackDetail->demandDescription->ID->Mark();
    for(i=0;i<10;i++)
      {
	copyAttackDetail->demandDescription->FR_set->Index(i)->Mark() = attackDetail->demandDescription->FR_set->Index(i)->Mark();
      };
    if(FlagSync->Mark() == 0)
      syncAttackSignal->Mark() = 1;	// Activates the synch channel only if triggered by non-sync attack. Suitable pluming is necessary (syncAttackSignal must be shared with syncAttack_occured.
    else
      FlagSync->Mark() = 0;
  }
// Eventually, the attackDetails structure is cleared
// successful_attack_occured->Mark() = 0;
attackDetail->ChanID->Mark() = 100;	// Will not be recognised as a valid channel;
attackDetail->demandDescription->ID->Mark() = 0;
for(i=0;i<10;i++)
  {
    attackDetail->demandDescription->FR_set->Index(i)->Mark() = 0;
  };
// Now trigger an update of system state. 
SystemStateUpdate->Mark() = 1;
cout << "Channel incremental pfd:" << pfd_increment; 
pfd_increment = ChannelState->initialPfd->Mark();
cout << "   Channel initial pfd:" << pfd_increment; 
pfd_increment = ChannelState->currentPfd->Mark();
cout << "   Channel current pfd:" << pfd_increment; 
i = ChannelState->channel_ID->Mark();
pfd_increment = ChannelState->commonFailurePfd->Mark();
cout << "   Channel " << i << " view on commonFailurepfd:" << pfd_increment; 
// Now check if compromise is detected
if(isPatchingDelayed > 0)
  {
    static UserDistributions dist(0, 31415);
    prob_threshold = (double)(dist.Uniform(0.0,1.0));
    // check if attack detected
    if(prob_threshold > compromise_detection_prob)
      {
	compromiseDetected->Mark() = 1;
      }
    cout << "   Channel " << i << " compromiseDetected:" << compromiseDetected->Mark() << "RNG value:" << prob_threshold; 
  }
  (*(attackCounter_Mobius_Mark))++;
  return this;
}

/*======================StartCleansingActivity========================*/


software_channelSAN::StartCleansingActivity::StartCleansingActivity(){
  ActivityInitialize("StartCleansing",5,Instantaneous , RaceEnabled, 6,2, false);
}

void software_channelSAN::StartCleansingActivity::LinkVariables(){
  CleansingTriggered->Register(&CleansingTriggered_Mobius_Mark);
  Mutex->Register(&Mutex_Mobius_Mark);
  Cleansing->Register(&Cleansing_Mobius_Mark);

  channel_attacked->Register(&channel_attacked_Mobius_Mark);
  SystemStateUpdate->Register(&SystemStateUpdate_Mobius_Mark);
}

bool software_channelSAN::StartCleansingActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((CleansingTriggered->Mark() > 0) && (Mutex->Mark() > 0)));
  return NewEnabled;
}

double software_channelSAN::StartCleansingActivity::Weight(){ 
  return 1;
}

bool software_channelSAN::StartCleansingActivity::ReactivationPredicate(){ 
  return false;
}

bool software_channelSAN::StartCleansingActivity::ReactivationFunction(){ 
  return false;
}

double software_channelSAN::StartCleansingActivity::SampleDistribution(){
  return 0;
}

double* software_channelSAN::StartCleansingActivity::ReturnDistributionParameters(){
    return NULL;
}

int software_channelSAN::StartCleansingActivity::Rank(){
  return 1;
}

BaseActionClass* software_channelSAN::StartCleansingActivity::Fire(){
  CleansingTriggered->Mark() = 0;
Mutex->Mark() = 0;
  ChannelState->isChannelUp->Mark() = 0;	// The channel is set to unavailable
// Now trigger an update of system state. 
channel_attacked->Mark() = ChannelState->channel_ID->Mark();
SystemStateUpdate->Mark() = 1;
  (*(Cleansing_Mobius_Mark))++;
  return this;
}

/*======================ChInitDoOnceActivity========================*/


software_channelSAN::ChInitDoOnceActivity::ChInitDoOnceActivity(){
  ActivityInitialize("ChInitDoOnce",6,Instantaneous , RaceEnabled, 5,1, false);
}

void software_channelSAN::ChInitDoOnceActivity::LinkVariables(){
  Channel_Init->Register(&Channel_Init_Mobius_Mark);
  Initialised_counter->Register(&Initialised_counter_Mobius_Mark);

  maxDemands->Register(&maxDemands_Mobius_Mark);
  initTokens->Register(&initTokens_Mobius_Mark);
}

bool software_channelSAN::ChInitDoOnceActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Channel_Init_Mobius_Mark)) >=1));
  return NewEnabled;
}

double software_channelSAN::ChInitDoOnceActivity::Weight(){ 
  return 1;
}

bool software_channelSAN::ChInitDoOnceActivity::ReactivationPredicate(){ 
  return false;
}

bool software_channelSAN::ChInitDoOnceActivity::ReactivationFunction(){ 
  return false;
}

double software_channelSAN::ChInitDoOnceActivity::SampleDistribution(){
  return 0;
}

double* software_channelSAN::ChInitDoOnceActivity::ReturnDistributionParameters(){
    return NULL;
}

int software_channelSAN::ChInitDoOnceActivity::Rank(){
  return 1;
}

BaseActionClass* software_channelSAN::ChInitDoOnceActivity::Fire(){
  (*(Channel_Init_Mobius_Mark))--;
  int i, j;
double dummy, rate;
i = ChannelState->channel_ID->Mark();
cout << "\n\nInit_Proc:\nChannel ID:" << i << "\n";
if(ChannelState->channel_ID->Mark() == 0)
  {
    ChannelState->initialPfd->Mark() = ch1_init_pfd;
    ChannelState->currentPfd->Mark() = ch1_init_pfd;
    if(demand_types_ch1 >= 20)
      demand_types_ch1 = 20;
      maxDemands->Mark() = demand_types_ch1;
//    initTokens->Mark() = demand_types_ch1;
    dummy = ch1_init_pfd;
  }
else
  {
    ChannelState->initialPfd->Mark() = ch2_init_pfd;
    ChannelState->currentPfd->Mark() = ch2_init_pfd;
    if(demand_types_ch2 >= 20)
      demand_types_ch2 = 20;
    maxDemands->Mark() = demand_types_ch2;   
//    initTokens->Mark() = demand_types_ch2;
    dummy = ch2_init_pfd;
  }
initTokens->Mark() = demand_types_max;	// Both channels initialised with max tokens; not all demands are active.  
ChannelState->isChannelUp->Mark() = 1; 
cout << "default ch1_pfd:" << ch1_init_pfd << " default ch2_pfd:" << ch2_init_pfd << "InitTokens: " << initTokens->Mark(); 
cout << "\nAssigned:" << dummy << "\n"; 

  (*(Initialised_counter_Mobius_Mark))++;
  return this;
}

/*======================StartPatchingActivity========================*/


software_channelSAN::StartPatchingActivity::StartPatchingActivity(){
  ActivityInitialize("StartPatching",7,Instantaneous , RaceEnabled, 8,3, false);
}

void software_channelSAN::StartPatchingActivity::LinkVariables(){
  PatchingTakingPlace->Register(&PatchingTakingPlace_Mobius_Mark);
  Mutex->Register(&Mutex_Mobius_Mark);
  compromiseDetected->Register(&compromiseDetected_Mobius_Mark);
  ChannelDown->Register(&ChannelDown_Mobius_Mark);
  PatchBuffer->Register(&PatchBuffer_Mobius_Mark);

  channel_attacked->Register(&channel_attacked_Mobius_Mark);
  SystemStateUpdate->Register(&SystemStateUpdate_Mobius_Mark);
}

bool software_channelSAN::StartPatchingActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((PatchingTakingPlace->Mark() > 0) && (Mutex->Mark() > 0) && ((compromiseDetected->Mark() > 0) || (isPatchingDelayed == 0))));
  return NewEnabled;
}

double software_channelSAN::StartPatchingActivity::Weight(){ 
  return 1;
}

bool software_channelSAN::StartPatchingActivity::ReactivationPredicate(){ 
  return false;
}

bool software_channelSAN::StartPatchingActivity::ReactivationFunction(){ 
  return false;
}

double software_channelSAN::StartPatchingActivity::SampleDistribution(){
  return 0;
}

double* software_channelSAN::StartPatchingActivity::ReturnDistributionParameters(){
    return NULL;
}

int software_channelSAN::StartPatchingActivity::Rank(){
  return 1;
}

BaseActionClass* software_channelSAN::StartPatchingActivity::Fire(){
  PatchBuffer->Mark() = PatchingTakingPlace->Mark();	// Store the number of delayed patches.
PatchingTakingPlace->Mark() = 0;
Mutex->Mark() = 0;
if(isPatchingDelayed > 0)
  compromiseDetected->Mark() = 0;
  ChannelState->isChannelUp->Mark() = 0;
// Now trigger an update of system state. 
channel_attacked->Mark() = ChannelState->channel_ID->Mark();
SystemStateUpdate->Mark() = 1;

  (*(ChannelDown_Mobius_Mark))++;
  return this;
}

/*======================bufferSyncAttackActivity========================*/


software_channelSAN::bufferSyncAttackActivity::bufferSyncAttackActivity(){
  ActivityInitialize("bufferSyncAttack",8,Instantaneous , RaceEnabled, 5,1, false);
}

void software_channelSAN::bufferSyncAttackActivity::LinkVariables(){
  syncroAttack_occurred->Register(&syncroAttack_occurred_Mobius_Mark);
  SyncDemand->Register(&SyncDemand_Mobius_Mark);



}

bool software_channelSAN::bufferSyncAttackActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(syncroAttack_occurred_Mobius_Mark)) >=1));
  return NewEnabled;
}

double software_channelSAN::bufferSyncAttackActivity::Weight(){ 
  return 1;
}

bool software_channelSAN::bufferSyncAttackActivity::ReactivationPredicate(){ 
  return false;
}

bool software_channelSAN::bufferSyncAttackActivity::ReactivationFunction(){ 
  return false;
}

double software_channelSAN::bufferSyncAttackActivity::SampleDistribution(){
  return 0;
}

double* software_channelSAN::bufferSyncAttackActivity::ReturnDistributionParameters(){
    return NULL;
}

int software_channelSAN::bufferSyncAttackActivity::Rank(){
  return 1;
}

BaseActionClass* software_channelSAN::bufferSyncAttackActivity::Fire(){
  (*(syncroAttack_occurred_Mobius_Mark))--;
  int i,j,found = 0;
// Ovewrite channel ID in the attack description. 
c_attackDetail->ChanID->Mark() = ChannelState->channel_ID->Mark();
// Now add the attack to the buffer of attacks.
for(i=0;i<20;i++)
  {
    if((int)(SyncBuffer->AttacksApplied->Index(i)->ID->Mark()) == (int)(c_attackDetail->demandDescription->ID->Mark()))
      {
	found = 1;
	break;
      }
    if((int)(SyncBuffer->AttacksApplied->Index(i)->ID->Mark()) == (int)(0))
       break;	// i will contain the index of an empty location
  };
if((found == 0) && (i < 20))	// if i >= 20 - buffer overflow would occur!!!
  {
    // Attack is new and will affect the channel and possibly system pfd. Add it to the buffer.
    SyncBuffer->AttacksApplied->Index(i)->ID->Mark() = c_attackDetail->demandDescription->ID->Mark();
    SyncBuffer->AttacksApplied->Index(i)->AttackRate->Mark() = c_attackDetail->demandDescription->AttackRate->Mark();
    SyncBuffer->AttacksApplied->Index(i)->successProb->Mark() = c_attackDetail->demandDescription->successProb->Mark();
    for(j=0;j<10;j++)
      {
    	SyncBuffer->AttacksApplied->Index(i)->FR_set->Index(j)->Mark() = c_attackDetail->demandDescription->FR_set->Index(j)->Mark();
      };
  }
else
  {
     if(found == 1)
       cout << "\n\n Repeat sync attack of channel:" << ChannelState->channel_ID;
     else
       cout << "\n\n Channel: " << ChannelState->channel_ID << " Sync attack buffer overflow";
  }
  (*(SyncDemand_Mobius_Mark))++;
  return this;
}

/*======================execSyncAttackActivity========================*/


software_channelSAN::execSyncAttackActivity::execSyncAttackActivity(){
  ActivityInitialize("execSyncAttack",9,Instantaneous , RaceEnabled, 10,1, false);
}

void software_channelSAN::execSyncAttackActivity::LinkVariables(){
  DataFromBuffer->Register(&DataFromBuffer_Mobius_Mark);
  attackCounter->Register(&attackCounter_Mobius_Mark);



  FlagSync->Register(&FlagSync_Mobius_Mark);
  syncAttackSignal->Register(&syncAttackSignal_Mobius_Mark);
  SystemStateUpdate->Register(&SystemStateUpdate_Mobius_Mark);
  compromiseDetected->Register(&compromiseDetected_Mobius_Mark);

}

bool software_channelSAN::execSyncAttackActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(DataFromBuffer_Mobius_Mark)) >=1));
  return NewEnabled;
}

double software_channelSAN::execSyncAttackActivity::Weight(){ 
  return 1;
}

bool software_channelSAN::execSyncAttackActivity::ReactivationPredicate(){ 
  return false;
}

bool software_channelSAN::execSyncAttackActivity::ReactivationFunction(){ 
  return false;
}

double software_channelSAN::execSyncAttackActivity::SampleDistribution(){
  return 0;
}

double* software_channelSAN::execSyncAttackActivity::ReturnDistributionParameters(){
    return NULL;
}

int software_channelSAN::execSyncAttackActivity::Rank(){
  return 1;
}

BaseActionClass* software_channelSAN::execSyncAttackActivity::Fire(){
  (*(DataFromBuffer_Mobius_Mark))--;
  int i,j,k,found_1;
int found = 0;
int curr_empty;
double pfd_increment = (double)(0.0);
double prob_threshold;
// Add the attack to the state and uldate the pfd figures 
i = ChannelState->channel_ID->Mark();
cout << "\n\nAttack Proc Gate\nChannel attacked:" << i << "\tAttack ID:" << attackDetail->demandDescription->ID->Mark() << "\n";
for(i=0;i<20;i++)
  {
    if(attackDetail->demandDescription->ID->Mark() == ChannelState->attacksApplied->Index(i)->ID->Mark())
 	found = 1;
    if(ChannelState->attacksApplied->Index(i)->ID->Mark() == 0)
      {
	curr_empty = i;		// Set the index of the first empty entry.
	break;
      }
   };
// Check if demand has already been applied. If so - do nothing. Otherwise add the demand to list of demands. 
if(found == 0)
  {
    // Not found: must add the new demandID to the list of demands.
    ChannelState->attacksApplied->Index(curr_empty)->ID->Mark() = attackDetail->demandDescription->ID->Mark();
    pfd_increment = (double)(0.0);
    for(i=0;i<10;i++)
      {
	// Here to copy the items of the FR_set
	if(attackDetail->demandDescription->FR_set->Index(i)->Mark() == 0)
	  break;	// If the item is set to 0, then abort. 
	ChannelState->attacksApplied->Index(curr_empty)->FR_set->Index(i)->Mark() = attackDetail->demandDescription->FR_set->Index(i)->Mark();
	found_1 = 0;
	for(j=0;j<100;j++)
	  {
	    if(attackDetail->demandDescription->FR_set->Index(i)->Mark() == ChannelState->FR_List->Index(j)->Mark())
	      found_1 = 1;
	    if(ChannelState->FR_List->Index(j)->Mark() == 0)
	      break;
	  };
	if(found_1 == 0)
	  {
	     // Here 'j' index contains the first empty location
	     ChannelState->FR_List->Index(j)->Mark() = attackDetail->demandDescription->FR_set->Index(i)->Mark();
	     // Now look up the contribution of this FR and add it to pfd_increment
	     for(k=0;k<100;k++)
		{
		  if(attackDetail->demandDescription->FR_set->Index(i)->Mark() == FR_Definition->Index(k)->ID->Mark())
		    pfd_increment += FR_Definition->Index(k)->pfd_size->Mark();
		};
	  }
      };
    // Add pfd_increment to this channel's pfd. 
    // This requires a pass through the ChannelState->FR_List.
    ChannelState->currentPfd->Mark() += pfd_increment;
  }
if((int)(time_sync_enabled) > 0)
  {
    // Copy attack details to copyAttackDetail of shared place
    copyAttackDetail->ChanID->Mark() = attackDetail->ChanID->Mark();
    copyAttackDetail->demandDescription->ID->Mark() = attackDetail->demandDescription->ID->Mark();
    for(i=0;i<10;i++)
      {
	copyAttackDetail->demandDescription->FR_set->Index(i)->Mark() = attackDetail->demandDescription->FR_set->Index(i)->Mark();
      };
    if(FlagSync->Mark() == 0)
      syncAttackSignal->Mark() = 1;	// Activates the synch channel only if triggered by non-sync attack. Suitable pluming is necessary (syncAttackSignal must be shared with syncAttack_occured.
    else
      FlagSync->Mark() = 0;
  }
// Eventually, the attackDetails structure is cleared
// successful_attack_occured->Mark() = 0;
attackDetail->ChanID->Mark() = 100;	// Will not be recognised as a valid channel;
attackDetail->demandDescription->ID->Mark() = 0;
for(i=0;i<10;i++)
  {
    attackDetail->demandDescription->FR_set->Index(i)->Mark() = 0;
  };
// Now trigger an update of system state. 
SystemStateUpdate->Mark() = 1;
cout << "Channel incremental pfd:" << pfd_increment; 
pfd_increment = ChannelState->initialPfd->Mark();
cout << "   Channel initial pfd:" << pfd_increment; 
pfd_increment = ChannelState->currentPfd->Mark();
cout << "   Channel current pfd:" << pfd_increment; 
i = ChannelState->channel_ID->Mark();
pfd_increment = ChannelState->commonFailurePfd->Mark();
cout << "   Channel " << i << " view on commonFailurepfd:" << pfd_increment; 
// Now check if compromise is detected
if(isPatchingDelayed > 0)
  {
    static UserDistributions dist(0, 31415);
    prob_threshold = (double)(dist.Uniform(0.0,1.0));
    // check if attack detected
    if(prob_threshold > compromise_detection_prob)
      {
	compromiseDetected->Mark() = 1;
      }
    cout << "   Channel " << i << " compromiseDetected:" << compromiseDetected->Mark() << "RNG value:" << prob_threshold; 
  }
  (*(attackCounter_Mobius_Mark))++;
  return this;
}

/*======================PatchingIntervalActivity========================*/

software_channelSAN::PatchingIntervalActivity::PatchingIntervalActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("PatchingInterval",0,Exponential, RaceEnabled, 2,1, false);
}

software_channelSAN::PatchingIntervalActivity::~PatchingIntervalActivity(){
  delete[] TheDistributionParameters;
}

void software_channelSAN::PatchingIntervalActivity::LinkVariables(){
  PatchingEnabled->Register(&PatchingEnabled_Mobius_Mark);
  PatchingTakingPlace->Register(&PatchingTakingPlace_Mobius_Mark);
}

bool software_channelSAN::PatchingIntervalActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(PatchingEnabled_Mobius_Mark)) >=1));
  return NewEnabled;
}

double software_channelSAN::PatchingIntervalActivity::Rate(){
  // old: activity was with deterministic duration as shown below
// patchingInterval = 2.2 [days]
// return(patchingInterval + 0.15 * (double)(ChannelState->channel_ID->Mark()));
//
// Now activity is exponentially distributed
return(patchingInterval);
  return 1.0;  // default rate if none is specified
}

double software_channelSAN::PatchingIntervalActivity::Weight(){ 
  return 1;
}

bool software_channelSAN::PatchingIntervalActivity::ReactivationPredicate(){ 
  return false;
}

bool software_channelSAN::PatchingIntervalActivity::ReactivationFunction(){ 
  return false;
}

double software_channelSAN::PatchingIntervalActivity::SampleDistribution(){
  return TheDistribution->Exponential(Rate());
}

double* software_channelSAN::PatchingIntervalActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int software_channelSAN::PatchingIntervalActivity::Rank(){
  return 1;
}

BaseActionClass* software_channelSAN::PatchingIntervalActivity::Fire(){
  (*(PatchingEnabled_Mobius_Mark))--;
  (*(PatchingTakingPlace_Mobius_Mark))++;
  return this;
}

/*======================CleansingDurationActivity========================*/

software_channelSAN::CleansingDurationActivity::CleansingDurationActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("CleansingDuration",1,Deterministic, RaceEnabled, 6,1, false);
}

software_channelSAN::CleansingDurationActivity::~CleansingDurationActivity(){
  delete[] TheDistributionParameters;
}

void software_channelSAN::CleansingDurationActivity::LinkVariables(){
  Cleansing->Register(&Cleansing_Mobius_Mark);
  CleansingCounter->Register(&CleansingCounter_Mobius_Mark);

  Mutex->Register(&Mutex_Mobius_Mark);
  channel_attacked->Register(&channel_attacked_Mobius_Mark);
  SystemStateUpdate->Register(&SystemStateUpdate_Mobius_Mark);
}

bool software_channelSAN::CleansingDurationActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Cleansing_Mobius_Mark)) >=1));
  return NewEnabled;
}

double software_channelSAN::CleansingDurationActivity::DeterministicParamValue(){
  return(upgrade_duration);
  return 1.0;  // default rate if none is specified
}

double software_channelSAN::CleansingDurationActivity::Weight(){ 
  return 1;
}

bool software_channelSAN::CleansingDurationActivity::ReactivationPredicate(){ 
  return false;
}

bool software_channelSAN::CleansingDurationActivity::ReactivationFunction(){ 
  return false;
}

double software_channelSAN::CleansingDurationActivity::SampleDistribution(){
  return(upgrade_duration);
}

double* software_channelSAN::CleansingDurationActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int software_channelSAN::CleansingDurationActivity::Rank(){
  return 1;
}

BaseActionClass* software_channelSAN::CleansingDurationActivity::Fire(){
  (*(Cleansing_Mobius_Mark))--;
  int i,j;
// Now need to clear the log of all attacks and FRs attached to this channel's state
ChannelState->currentPfd->Mark() = ChannelState->initialPfd->Mark();
for(i=0;i<20;i++)
  {
    ChannelState->attacksApplied->Index(i)->ID->Mark() = 0;
    for(j=0;j<10;j++)
      {
	ChannelState->attacksApplied->Index(i)->FR_set->Index(j)->Mark() = 0;
      };
  };
// Leave FR_List to UpdateSystemState.
ChannelState->isChannelUp->Mark() = 1;
// Now trigger an update of system state. 
Mutex->Mark() = 1;	// Exit Mutex;
channel_attacked->Mark() = ChannelState->channel_ID->Mark();
SystemStateUpdate->Mark() = 1;
  (*(CleansingCounter_Mobius_Mark))++;
  return this;
}

/*======================PatchingDurationActivity========================*/

software_channelSAN::PatchingDurationActivity::PatchingDurationActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("PatchingDuration",2,Deterministic, RaceEnabled, 9,1, false);
}

software_channelSAN::PatchingDurationActivity::~PatchingDurationActivity(){
  delete[] TheDistributionParameters;
}

void software_channelSAN::PatchingDurationActivity::LinkVariables(){
  ChannelDown->Register(&ChannelDown_Mobius_Mark);
  PatchingEnabled->Register(&PatchingEnabled_Mobius_Mark);
  PatchingCounter->Register(&PatchingCounter_Mobius_Mark);

  PatchBuffer->Register(&PatchBuffer_Mobius_Mark);
  Mutex->Register(&Mutex_Mobius_Mark);
  channel_attacked->Register(&channel_attacked_Mobius_Mark);
  SystemStateUpdate->Register(&SystemStateUpdate_Mobius_Mark);

}

bool software_channelSAN::PatchingDurationActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(ChannelDown_Mobius_Mark)) >=1));
  return NewEnabled;
}

double software_channelSAN::PatchingDurationActivity::DeterministicParamValue(){
  // Here to check the channel and return a value.
return(upgrade_duration);
  return 1.0;  // default rate if none is specified
}

double software_channelSAN::PatchingDurationActivity::Weight(){ 
  return 1;
}

bool software_channelSAN::PatchingDurationActivity::ReactivationPredicate(){ 
  return false;
}

bool software_channelSAN::PatchingDurationActivity::ReactivationFunction(){ 
  return false;
}

double software_channelSAN::PatchingDurationActivity::SampleDistribution(){
  // Here to check the channel and return a value.
return(upgrade_duration);
}

double* software_channelSAN::PatchingDurationActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int software_channelSAN::PatchingDurationActivity::Rank(){
  return 1;
}

BaseActionClass* software_channelSAN::PatchingDurationActivity::Fire(){
  (*(ChannelDown_Mobius_Mark))--;
  int i,j;
double dummy;
// Now need to clear the log of all attacks and FRs attached to this channel's state
for(i=0;i<20;i++)
  {
    ChannelState->attacksApplied->Index(i)->ID->Mark() = 0;
    for(j=0;j<10;j++)
      {
	ChannelState->attacksApplied->Index(i)->FR_set->Index(j)->Mark() = 0;
      };
  };
// Leave FR_List to UpdateSystemState.
//
// Now must do something to model the effect of patching:
// - reduce initial pfd
// - reduce the likelihood of success of some of the malicious demands (possibly setting them to 0)
//
dummy = ChannelState->initialPfd->Mark();
i = ChannelState->channel_ID->Mark();
j = ChannelState->isChannelUp->Mark();
cout << "\n\nPatchingUp channel " << i << "\nchannel state:" << j << "\n";
dummy = ChannelState->currentPfd->Mark();
cout << "Current initial pfd:" << dummy << "\n";
// dummy = ChannelState->initialPfd->Mark() * (double)(0.9);	// A hardcoded reduction of initial pfd.
dummy = ChannelState->initialPfd->Mark() * patching_channel_pfd_reduction;
ChannelState->initialPfd->Mark() = dummy ;	
cout << "New initial pfd:" << dummy << "\n";

ChannelState->currentPfd->Mark() = ChannelState->initialPfd->Mark();
dummy = ChannelState->currentPfd->Mark();
cout << "New current pfd:" << dummy << "\n";
// Now reduce the systemPfd
dummy = ChannelState->commonFailurePfd->Mark() * patching_common_pfd_reduction;	// Reduceds system pfd
// Now add a routine to reduce the success rate of attacks.
switch(patching_model)
  {
    case 1: // Model 1.
      for (i=0;i<20;i++)
	{
	  for(j=0;j<PatchBuffer->Mark();j++)
	    {
	      // Apply success reduction as necessary to account for all delayed patches. 
	      dummy = ChanAttackList->AttacksApplied->Index(i)->successProb->Mark() * attack_success_prob_reduction;
	      ChanAttackList->AttacksApplied->Index(i)->successProb->Mark() = dummy;
	    }
	  // No need to reset PatchBuffer to 0 as it is always overwritten by the next new patch. 
	}
      cout << "\n\nPatchingUp channel " << ChannelState->channel_ID->Mark() << "\nPatchBuffer size:" << PatchBuffer->Mark() << "\n";
     break;
    case 2: // Model 2
     break;
    case 3:
     break;
    default : // including 0. Do nothing
     break;
  }
ChannelState->isChannelUp->Mark() = 1;
// Now trigger an update of system state. 
Mutex->Mark() = 1;	// Exit Mutex;
// Now make the channel causing the update known to system_state model
channel_attacked->Mark() = ChannelState->channel_ID->Mark();
SystemStateUpdate->Mark() = 1;


  (*(PatchingEnabled_Mobius_Mark))++;
  (*(PatchingEnabled_Mobius_Mark))++;
  (*(PatchingCounter_Mobius_Mark))++;
  return this;
}

/*======================processSyncActivity========================*/

software_channelSAN::processSyncActivity::processSyncActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("processSync",3,Deterministic, RaceEnabled, 5,1, false);
}

software_channelSAN::processSyncActivity::~processSyncActivity(){
  delete[] TheDistributionParameters;
}

void software_channelSAN::processSyncActivity::LinkVariables(){
  SyncDemand->Register(&SyncDemand_Mobius_Mark);
  DataFromBuffer->Register(&DataFromBuffer_Mobius_Mark);
  FlagSync->Register(&FlagSync_Mobius_Mark);


}

bool software_channelSAN::processSyncActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(SyncDemand_Mobius_Mark)) >=1));
  return NewEnabled;
}

double software_channelSAN::processSyncActivity::DeterministicParamValue(){
  return(delay_sync_attack);
  return 1.0;  // default rate if none is specified
}

double software_channelSAN::processSyncActivity::Weight(){ 
  return 1;
}

bool software_channelSAN::processSyncActivity::ReactivationPredicate(){ 
  return false;
}

bool software_channelSAN::processSyncActivity::ReactivationFunction(){ 
  return false;
}

double software_channelSAN::processSyncActivity::SampleDistribution(){
  return(delay_sync_attack);
}

double* software_channelSAN::processSyncActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int software_channelSAN::processSyncActivity::Rank(){
  return 1;
}

BaseActionClass* software_channelSAN::processSyncActivity::Fire(){
  (*(SyncDemand_Mobius_Mark))--;
  int i, j;
// Here I take the malicious demand from the top of the SyncBuffer and place it for processing in attackDetail.
// The actual processing will take place in AttackProc gate. 
attackDetail->demandDescription->ID->Mark() = SyncBuffer->AttacksApplied->Index(0)->ID->Mark();
attackDetail->demandDescription->AttackRate->Mark() = SyncBuffer->AttacksApplied->Index(0)->AttackRate->Mark();
attackDetail->demandDescription->successProb->Mark() = SyncBuffer->AttacksApplied->Index(0)->successProb->Mark();
for(j=0;j<10;j++)
  {
    attackDetail->demandDescription->FR_set->Index(j)->Mark() = SyncBuffer->AttacksApplied->Index(0)->FR_set->Index(j)->Mark();
  };
SyncBuffer->AttacksApplied->Index(0)->ID->Mark() = 0;	// This is important in case there is only one demand in SyncBuffer.
// Then the top element is removed from syncBuffer (i.e. moving all pending demands up the buffer)
for(i=1;i<20;i++)
  {
    if(SyncBuffer->AttacksApplied->Index(i)->ID->Mark() == 0)
      break;
    else
      {
	SyncBuffer->AttacksApplied->Index(i-1)->ID->Mark() = SyncBuffer->AttacksApplied->Index(i)->ID->Mark();
	SyncBuffer->AttacksApplied->Index(i)->ID->Mark() = 0;	// Mark the last element in the buffer as empty. 
	SyncBuffer->AttacksApplied->Index(i-1)->AttackRate->Mark() = SyncBuffer->AttacksApplied->Index(i)->AttackRate->Mark();;
	SyncBuffer->AttacksApplied->Index(i-1)->successProb->Mark() = SyncBuffer->AttacksApplied->Index(i)->successProb->Mark();;
	for(j=0;j<10;j++)
  	  {
    	    SyncBuffer->AttacksApplied->Index(i-1)->FR_set->Index(j)->Mark() = SyncBuffer->AttacksApplied->Index(i)->FR_set->Index(j)->Mark();
  	  };
      }
  };

  (*(DataFromBuffer_Mobius_Mark))++;
  (*(FlagSync_Mobius_Mark))++;
  return this;
}

