#ifndef SW_channelRJ__CH2_Join_H_
#define SW_channelRJ__CH2_Join_H_
#include <math.h>
#include "Cpp/Composer/Join.h"
#include "Cpp/Composer/AllStateVariableTypes.h"
#include "Composed/SW_channel/SW_channelRJ__Rep2.h"
#include "Atomic/software_channel/software_channelSAN.h"
#include "Atomic/Attack_Evolution/Attack_EvolutionSAN.h"

//State variable headers
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
extern short demand_types_ch1;
extern short demand_types_ch2;

class SW_channelRJ__CH2_Join: public Join {
 public:
  SW_channelRJ__Rep2 * Rep2;
  software_channelSAN * software_channel_2;
  Attack_EvolutionSAN * Ch2_Attack_Evolution;
  channelState * ChannelState_ch2;
  Place * Channel_ID_2;
  Place * Channel_Init_2;
  Place * CleansingTrigger_ch2;
  FR_Array * FR_Definition;
  Place * InitTokens;
  channelAttack * Input;
  ChannelAttackList * ListOfAttacks;
  Place * Mutex;
  Place * SystemStateUpdate;
  channelAttack * c_attackDetail_2;
  Place * channel_initialised_2;
  channelAttack * copyAttackDetail_2;
  Place * maxDemands;
  Place * successful_attack_occured;
  Place * syncAttackSignal_2;
  Place * syncroAttack_occurred_2;

  SW_channelRJ__CH2_Join();
  ~SW_channelRJ__CH2_Join();
};

#endif
