#ifndef SW_channelRJ__Rep2_H_
#define SW_channelRJ__Rep2_H_
#include <math.h>
#include "Cpp/Composer/Rep.h"
#include "Cpp/Composer/AllStateVariableTypes.h"

//Submodel header files
#include "Atomic/Malicious_Demands_Init/Malicious_Demands_InitSAN.h"

//State variable headers
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
extern short demand_types_ch1;
extern short demand_types_ch2;

class SW_channelRJ__Rep2: public Rep {
 public:
  Malicious_Demands_InitSAN ** InstanceArray;

  SW_channelRJ__Rep2();
  ~SW_channelRJ__Rep2();

  // Declare new variables
  Place * Channel_ID;
  Place * DemandSubmitted;
  Place * InitTokens;
  channelAttack * Input;
  ChannelAttackList * ListOfAttacks;
  Place * channel_initialised;
  Place * maxDemands;
};

#endif
