#ifndef SW_channelRJ__CH1_Join_H_
#define SW_channelRJ__CH1_Join_H_
#include <math.h>
#include "Cpp/Composer/Join.h"
#include "Cpp/Composer/AllStateVariableTypes.h"
#include "Composed/SW_channel/SW_channelRJ__Rep1.h"
#include "Atomic/software_channel/software_channelSAN.h"
#include "Atomic/Attack_Evolution/Attack_EvolutionSAN.h"

//State variable headers
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
extern short demand_types_ch1;
extern short demand_types_ch2;

class SW_channelRJ__CH1_Join: public Join {
 public:
  SW_channelRJ__Rep1 * Rep1;
  software_channelSAN * software_channel;
  Attack_EvolutionSAN * Ch1_Attack_Evolution;
  channelState * ChannelState_ch1;
  Place * Channel_ID_1;
  Place * Channel_Init_1;
  Place * CleansingTrigger_ch1;
  FR_Array * FR_Definition;
  Place * InitTokens;
  channelAttack * Input;
  ChannelAttackList * ListOfAttacks;
  Place * Mutex;
  Place * SystemStateUpdate;
  channelAttack * c_attackDetail_1;
  Place * channel_initialised_1;
  channelAttack * copyAttackDetail_1;
  Place * maxDemands;
  Place * successful_attack_occured;
  Place * syncAttackSignal_1;
  Place * syncroAttack_occurred_1;

  SW_channelRJ__CH1_Join();
  ~SW_channelRJ__CH1_Join();
};

#endif
